# This makes a blue_list array for you, that is, it makes an array of boxes that
# are not calculated. You can also have the blue field control code generated for
# you by choosing what type of control. The %w part is a shorthand way of indicating
# that all boxes are actually between double quotes and comma separated.
#
# The created code is then output to the output pane and ALSO copied to the clipboard for you.
#
# What you need to do:
#
# 1) From your code file do a Ctrl-A then a Ctrl-C to first select then copy ALL of the file's contents
#	to the clipboard. The boxArray is built from the 'Field Data' boxes once you press F5 in
#	step 3) below, so every box on the document ends up in this array.
#
# 2) Select what type of blue field control by setting the type to 't' for True
#	or 'f' for False - case does not matter. Make sure only one type is set to 't'. If you want
#	 just the box list then make sure all types are 'f' or you can remove any type code after
#	 the tool runs.
#
# 3) Then press F5 from SciTe while in THIS code file. The below code will build a box array of
#	calculated boxes, the difference between this array and the document's box array mentioned
#	in 1) above will give you the blue box array/list. Output goes to the output pane and it is
#	also copied to the clipboard.
#
# IMPORTANT: You will need to inspect the list for boxes that should not be in there,
# this will depend on your intended usage of the array. Hopefully you will not need to add any boxes.
#
#-#########################
#
# In this area select what type of blue field control you want to do.
# These types have been verified to convert to JS and function as expected.
#
#-#########################
#
# Set the box value to 0 if it is empty:
type1 = 'f'

# Round the box value and append a decimal point if it is not empty.
type2 = 't'

#-###################################################
#
# Beachtung! ndere nichts unter dieser Zeile! [Do not change anything below.....]
#
#-###################################################

require 'tk'

calcBoxArray = Array.new
boxArray = Array.new
calcsStr = TkClipboard.get(nil)
fieldData = false

calcsStr.each do |line|

	case
		when (line =~ /^#\s+\*+\s+Field Data\s+\*+$/)

			fieldData = true
			calcBoxArray.clear

		when (line =~ /^#\s+\*+\s+Calculations\s+\*+$/)

			fieldData = false

		when (fieldData)

			if (line =~ (/^(box\d+_\d+) = /))
				boxArray.push($1) unless ($1 == 'box1_65535')
			end
		else
			if (line =~ (/\s*(box\d+_\d+)( *=)?/))

				calcBoxArray.push($1) if (($2) and ($1 != 'box1_65535'))
	
				line.scan(/box\d+_\d+/).uniq.each do |box|
					boxArray.push(box) unless ((box == 'box1_65535') or (boxArray.include?(box)))
				end
			end
	end
end

blueBoxArray = boxArray - calcBoxArray

#~ print "\n\n"
#~ p boxArray
#~ print "\n\n"
#~ p calcBoxArray
#~ print "\n\n"
#~ p blueBoxArray

# Make the %w{..} box list from the blueBoxArray

codeStr = ""

codeStr += "\n\nblue_list = %w{"

blueBoxArray.each do |box|
	codeStr += "#{box} "
end

codeStr = codeStr.chomp(" ") + "}\n\n"

# Now add the code based on which type of blue field control was selected else you get just the box list:
case
	when (type1.upcase == 'T')

		# Empty boxes are to display a zero '0'.
		codeStr += "blue_list.each do |x|\n\tprint x, eval(\"\#{x}.replace(\#{x}.to_f.round.to_s)\") if eval(\"\#{x}\").strip.empty?\nend\n\n"

	when (type2.upcase == 'T')

		# Round the box value and append a decimal point if it is not empty.
		codeStr += "blue_list.each do |x|\n\tprint x, eval(\"\#{x}.replace(\#{x}.to_f.round.to_s + '.')\") unless eval(\"\#{x}\").strip.empty?\nend\n\n"
end

#
# TkClipboard.set first clears the clipboard.
#
TkClipboard.set(codeStr.empty? ? '' : codeStr, nil)

print codeStr

